library wkLogKeyboardLayout;

uses
  Windows, SysUtils;

// ***************************************************************

var
  MyThreadID, ThreadID: Cardinal;

procedure ThreadProc(Nothing: Pointer); stdcall;
var
  Pressed: Boolean;
  F: Text;
begin
  Pressed := False;
  repeat
    if (GetKeyState(VK_SHIFT)<0) and
       (GetKeyState(VK_F12)<0) then
      if not Pressed then
      begin
        Assign(F, 'KeyboardLayoutLog.txt');
        {$I-}
        Append(F);
        {$I+}
        if IOResult<>0 then
          ReWrite(F);
        WriteLn(F, IntToHex(GetKeyboardLayout(MyThreadID), 8));
        Close(F);
        Pressed := True;
      end
      else
    else
      if Pressed then
        Pressed := False;
    Sleep(10);
  until False;
end;

// ***************************************************************

begin
  MyThreadID := GetCurrentThreadID;
  CreateThread(nil, 0, @ThreadProc, nil, 0, ThreadID);
end.
